# pb_ds::tree< Key, Mapped, Cmp_Fn, Tag, Node_Update, Allocator > Class Template Reference

Inheritance diagram for pb_ds::tree< Key, Mapped, Cmp_Fn, Tag, Node_Update, Allocator >:

List of all members.

## Detailed Description

### template<typename Key, typename Mapped, typename Cmp_Fn = std::less<Key>, typename Tag = rb_tree_tag, template< typename Const_Node_Iterator, typename Node_Iterator, typename Cmp_Fn_, typename Allocator_ > class Node_Update = pb_ds::null_tree_node_update, typename Allocator = std::allocator<char>>
class pb_ds::tree< Key, Mapped, Cmp_Fn, Tag, Node_Update, Allocator >

Definition at line 500 of file assoc_container.hpp.

## Public Types

- typedef Allocator allocator
- typedef Cmp_Fn cmp_fn
- typedef base_type::const_iterator const_iterator
- typedef key_rebind::const_pointer const_key_pointer
- typedef key_rebind::const_reference const_key_reference
- typedef mapped_rebind::const_pointer const_mapped_pointer
- typedef mapped_rebind::const_reference const_mapped_reference
- typedef base_type::const_point_iterator const_point_iterator
- typedef value_rebind::const_pointer const_pointer
- typedef value_rebind::const_reference const_reference
- typedef Tag container_category
- typedef allocator::difference_type difference_type
- typedef base_type::iterator iterator
- typedef key_rebind::pointer key_pointer
- typedef allocator::template
  rebind< key_type >::other key_rebind
- typedef key_rebind::reference key_reference
- typedef allocator::template
  rebind< Key >::other::value_type key_type
- typedef mapped_rebind::pointer mapped_pointer
- typedef allocator::template
  rebind< mapped_type >::other mapped_rebind
- typedef mapped_rebind::reference mapped_reference
- typedef Mapped mapped_type
- typedef detail::tree_traits<
  Key, Mapped, Cmp_Fn, Node_Update,
  Tag, Allocator >::node_update node_update
- typedef base_type::point_iterator point_iterator
- typedef value_rebind::pointer pointer
- typedef value_rebind::reference reference
- typedef allocator::size_type size_type
- typedef allocator::template
  rebind< value_type >::other value_rebind
- typedef base_type::value_type value_type

## Public Member Functions

- tree & operator= (const tree &other)
- void swap (tree &other)
- tree (const tree &other)
- template<typename It> tree (It first, It last, const cmp_fn &c)
- template<typename It> tree (It first, It last)
- tree (const cmp_fn &c)
- tree ()
- virtual ~tree ()

The documentation for this class was generated from the following file:

- assoc_container.hpp